# ApplicationFramework
TKTObj
TObj

# TObj_TReference Class Reference

`#include <TObj_TReference.hxx>`

Inheritance diagram for TObj_TReference:

[legend]

## Public Member Functions

Standard_EXPORT | TObj_TReference ()
| Standard methods of OCAF attribute Empty constructor.
Standard_EXPORT const Standard_GUID & | ID () const
| Returns the ID of TObj_TReference attribute.
static Standard_EXPORT const | Handle (TObj_Object)&theObject
static Standard_EXPORT const const | Handle (TObj_Object)&theMaster)
Standard_EXPORT void | Set (const Handle(TObj_Object)&theObject, const TDF_Label &theMasterLabel)
| Methods for setting and obtaining referenced object Sets the reference to the theObject.
Standard_EXPORT void | Set (const TDF_Label &theLabel, const TDF_Label &theMasterLabel)
| Sets the reference to the theObject at indicated Label. It is method for persistent only. Don`t use anywhere else.
Standard_EXPORT | Handle (TObj_Object) Get() const
| Returns the referenced theObject.
Standard_EXPORT TDF_Label | GetMasterLabel () const
| Returns the Label of master object.
Standard_EXPORT TDF_Label | GetLabel () const
| Returns the referred label.
Standard_EXPORT | Handle (TDF_Attribute) NewEmpty() const
| Redefined OCAF abstract methods Returns an new empty TObj_TReference attribute. It is used by the copy algorithm.
Standard_EXPORT void | Restore (const Handle(TDF_Attribute)&theWith)
| Restores the backuped contents from <thewith> into this one. It is used when aborting a transaction.
Standard_EXPORT void | Paste (const Handle(TDF_Attribute)&theInto, const Handle(TDF_RelocationTable)&theRT) const
| This method is used when copying an attribute from a source structure into a target structure.
virtual Standard_EXPORT void | BeforeForget ()
| Remove back references of it reference if it is in other document.
virtual Standard_EXPORT Standard_Boolean | BeforeUndo (const Handle(TDF_AttributeDelta)&theDelta, const Standard_Boolean isForced=Standard_False)
| It is necessary for tranzaction mechanism (Undo/Redo).
virtual Standard_EXPORT Standard_Boolean | AfterUndo (const Handle(TDF_AttributeDelta)&theDelta, const Standard_Boolean isForced=Standard_False)
| It is necessary for tranzaction mechanism (Undo/Redo).
virtual Standard_EXPORT void | AfterResume ()
| Check if back reference exists for reference.
virtual Standard_EXPORT Standard_Boolean | AfterRetrieval (const Standard_Boolean forceIt=Standard_False)
| Called after retrieval reference from file.

## Static Public Member Functions

static Standard_EXPORT const Standard_GUID & | GetID ()
| This method is used in implementation of ID().
static Standard_EXPORT | Handle (TObj_TReference) Set(const TDF_Label &theLabel
| Method for create TObj_TReference object Creates reference on TDF_Label <thelabel> to the object <theobject> and creates backreference from the object <theobject> to <themaster> one.

## Private Attributes

TDF_Label | myLabel
| Label that indicate referenced object.
TDF_Label | myMasterLabel
| Label of object that have this reference.

## Detailed Description

Attribute for storing references to the objects which implement TObj_Object interface in the OCAF tree. Its persistency mechanism provides transparent method for storing cross-model references. Each reference, when created, registers itself in the referred object, to support back references

## Constructor & Destructor Documentation

Standard_EXPORT TObj_TReference::TObj_TReference | ( |  | ) |

## Member Function Documentation

virtual Standard_EXPORT void TObj_TReference::AfterResume | ( |  | ) | `[virtual]`

| Reimplemented from TDF_Attribute.

virtual Standard_EXPORT Standard_Boolean TObj_TReference::AfterRetrieval | ( | const Standard_Boolean | forceIt = `Standard_False` | ) | `[virtual]`

| Reimplemented from TDF_Attribute.

virtual Standard_EXPORT Standard_Boolean TObj_TReference::AfterUndo | ( | const Handle(TDF_AttributeDelta)& | theDelta,
|  | const Standard_Boolean | isForced = `Standard_False`
| ) | `[virtual]`

| Reimplemented from TDF_Attribute.

virtual Standard_EXPORT void TObj_TReference::BeforeForget | ( |  | ) | `[virtual]`

| Reimplemented from TDF_Attribute.

virtual Standard_EXPORT Standard_Boolean TObj_TReference::BeforeUndo | ( | const Handle(TDF_AttributeDelta)& | theDelta,
|  | const Standard_Boolean | isForced = `Standard_False`
| ) | `[virtual]`

| Reimplemented from TDF_Attribute.

static Standard_EXPORT const Standard_GUID& TObj_TReference::GetID | ( |  | ) | `[static]`

Standard_EXPORT TDF_Label TObj_TReference::GetLabel | ( |  | ) | const`[inline]`

Standard_EXPORT TDF_Label TObj_TReference::GetMasterLabel | ( |  | ) | const`[inline]`

Standard_EXPORT TObj_TReference::Handle | ( | TDF_Attribute |  | ) | const

Standard_EXPORT TObj_TReference::Handle | ( | TObj_Object |  | ) | const

static Standard_EXPORT const const TObj_TReference::Handle | ( | TObj_Object |  | ) |

static Standard_EXPORT const TObj_TReference::Handle | ( | TObj_Object |  | ) |

static Standard_EXPORT TObj_TReference::Handle | ( | TObj_TReference |  | ) | const`[static]`

Standard_EXPORT const Standard_GUID& TObj_TReference::ID | ( |  | ) | const`[virtual]`

| Implements TDF_Attribute.

Standard_EXPORT void TObj_TReference::Paste | ( | const Handle(TDF_Attribute)& | theInto,
|  | const Handle(TDF_RelocationTable)& | theRT
| ) | const`[virtual]`

| Implements TDF_Attribute.

Standard_EXPORT void TObj_TReference::Restore | ( | const Handle(TDF_Attribute)& | theWith | ) | `[virtual]`

| Implements TDF_Attribute.

Standard_EXPORT void TObj_TReference::Set | ( | const TDF_Label & | theLabel,
|  | const TDF_Label & | theMasterLabel
| ) |

Standard_EXPORT void TObj_TReference::Set | ( | const Handle(TObj_Object)& | theObject,
|  | const TDF_Label & | theMasterLabel
| ) |

## Field Documentation

TDF_Label TObj_TReference::myLabel `[private]`

TDF_Label TObj_TReference::myMasterLabel `[private]`

The documentation for this class was generated from the following file:

- TObj_TReference.hxx